MONGOD(1)

NAME
mongod - MongoDB Server

  On this page

•   Synopsis

•   Options

•   Core Options

•   Free Monitoring

•   LDAP Authentication or Authorization Options

•   Storage Options

•   WiredTiger Options

•   Replication Options

•   Sharded Cluster Options

•   TLS Options

•   SSL Options (Deprecated)

•   Profiler Options

•   Audit Options

•   SNMP Options

•   inMemory Options

•   Encryption Key Management Options

SYNOPSIS

mongod is the primary daemon process for the MongoDB system. It handles data requests, manages data access, and performs background management operations.

This document provides a complete overview of all command line options for mongod. These command line options are primarily useful for testing: In common operation, use the configuration file options to control the behavior of your database.

SEE ALSO: conf-file-command-line-mapping

NOTE: Starting in version 4.0, MongoDB disables support for TLS 1.0 encryption on systems where TLS 1.1+ is available. For more details, see 4.0-disable-tls.

OPTIONS

Starting in version 4.2

•   MongoDB deprecates the SSL options and insteads adds new corresponding TLS options.

•   MongoDB adds --tlsClusterCAFile/net.tls.clusterCAFile. (Also availalbe in 3.4.18+, 3.6.9+, 4.0.3+)

Starting in version 4.4

•   MongoDB removes the --noIndexBuildRetry command-line option and the corresponding storage.indexBuildRetry option.

  Core Options

--help, -h
    Returns information on the options and use of mongod.

--version
    Returns the mongod release number.

--config <filename>, -f <filename>
    Specifies a configuration file for runtime configuration options. The configuration file is the preferred method for runtime configuration of mongod. The options are equivalent to the command-line configuration options. See /reference/configuration-options for more information.

    Ensure the configuration file uses ASCII encoding. The mongod instance does not support configuration files with non-ASCII encoding, including UTF-8.

--configExpand <none|rest|exec>
    Default: none

    New in version 4.2.

    Enables using Expansion Directives in configuration files. Expansion directives allow you to set externally sourced values for configuration file options.

    --configExpand supports the following expansion directives:
    Value | Description
    none | Default. mongod does not expand expansion directives. mongod fails to start if any configuration file settings use expansion directives.
    rest | mongod expands __rest expansion directives when parsing the configuration file.
    exec | mongod expands __exec expansion directives when parsing the configuration file.

    You can specify multiple expansion directives as a comma-separated list, e.g. rest, exec. If the configuration file contains expansion directives not specified to --configExpand, the mongod returns an error and terminates.

    See externally-sourced-values for configuration files for more information on expansion directives.

--verbose, -v
    Increases the amount of internal reporting returned on standard output or in log files. Increase the verbosity with the -v form by including the option multiple times, (e.g. -vvvvv.)

    NOTE: Starting in version 4.2, MongoDB includes the Debug verbosity level (1-5) in the log messages. For example, if the verbosity level is 2, MongoDB logs D2. In previous versions, MongoDB log messages only specified D for Debug level.

--quiet
    Runs mongod in a quiet mode that attempts to limit the amount of output.

    This option suppresses:

•   output from database commands

•   replication activity

•   connection accepted events

•   connection closed events

--port <port>
    Default:

•   27017 if mongod is not a shard member or a config server member

•   27018 if mongod is a shard member

•   27019 if mongod is a config server member

    The TCP port on which the MongoDB instance listens for client connections.

--bind_ip <hostnames|ipaddresses|Unix domain socket paths>
    Default: localhost

    NOTE: Starting in MongoDB 3.6, mongod bind to localhost by default. See 3.6-bind-to-localhost.

    The hostnames and/or IP addresses and/or full Unix domain socket paths on which mongod should listen for client connections. You may attach mongod to any interface. To bind to multiple addresses, enter a list of comma-separated values.

  Example

localhost,/tmp/mongod.sock

You can specify both IPv4 and IPv6 addresses, or hostnames that resolve to an IPv4 or IPv6 address.

  Example

localhost, 2001:0DB8:e132:ba26:0d5c:2774:e7f9:d513

NOTE: If specifying an IPv6 address or a hostname that resolves to an IPv6 address to --bind_ip, you must start mongod with --ipv6 to enable IPv6 support. Specifying an IPv6 address to --bind_ip does not enable IPv6 support.

If specifying a link-local IPv6 address (fe80::/10), you must append the zone index to that address (i.e. fe80::<address>%<adapter-name>).

  Example

localhost,fe80::a00:27ff:fee0:1fcf%enp0s3

  Tip

When possible, use a logical DNS hostname instead of an ip address, particularly when configuring replica set members or sharded cluster members. The use of logical DNS hostnames avoids configuration changes due to ip address changes.

WARNING: Before binding to a non-localhost (e.g. publicly accessible) IP address, ensure you have secured your cluster from unauthorized access. For a complete list of security recommendations, see /administration/security-checklist. At minimum, consider enabling authentication and hardening network infrastructure.

For more information about IP Binding, refer to the /core/security-mongodb-configuration documentation.

To bind to all IPv4 addresses, enter 0.0.0.0.

To bind to all IPv4 and IPv6 addresses, enter ::,0.0.0.0 or starting in MongoDB 4.2, an asterisk "*" (enclose the asterisk in quotes to avoid filename pattern expansion). Alternatively, use the net.bindIpAll setting.

NOTE:

•   --bind_ip and --bind_ip_all are mutually exclusive. Specifying both options causes mongod to throw an error and terminate.

•   The command-line option --bind overrides the configuration file setting net.bindIp.

--bind_ip_all
    New in version 3.6.

    If specified, the mongod instance binds to all IPv4 addresses (i.e. 0.0.0.0). If mongod starts with --ipv6, --bind_ip_all also binds to all IPv6 addresses (i.e. ::).

    mongod only supports IPv6 if started with --ipv6. Specifying --bind_ip_all alone does not enable IPv6 support.

    WARNING: Before binding to a non-localhost (e.g. publicly accessible) IP address, ensure you have secured your cluster from unauthorized access. For a complete list of security recommendations, see /administration/security-checklist. At minimum, consider enabling authentication and hardening network infrastructure.

    For more information about IP Binding, refer to the /core/security-mongodb-configuration documentation.

    Alternatively, you can set the --bind_ip option to ::,0.0.0.0 or, starting in MongoDB 4.2, to an asterisk "*" (enclose the asterisk in quotes to avoid filename pattern expansion).

    NOTE: --bind_ip and --bind_ip_all are mutually exclusive. That is, you can specify one or the other, but not both.

--clusterIpSourceWhitelist <string>
    New in version 3.6.

    A list of IP addresses/CIDR (Classless Inter-Domain Routing) ranges against which the mongod validates authentication requests from other members of the replica set and, if part of a sharded cluster, the mongos instances. The mongod verifies that the originating IP is either explicitly in the list or belongs to a CIDR range in the list. If the IP address is not present, the server does not authenticate the mongod or mongos.

    --clusterIpSourceWhitelist has no effect on a mongod started without authentication.

    --clusterIpSourceWhitelist accepts multiple comma-separated IPv4/6 addresses or Classless Inter-Domain Routing (CIDR) ranges:

    mongod --clusterIpSourceWhitelist 192.0.2.0/24,127.0.0.1,::1

    IMPORTANT: Ensure --clusterIpSourceWhitelist includes the IP address or CIDR ranges that include the IP address of each replica set member or mongos in the deployment to ensure healthy communication between cluster components.

--ipv6
    Enables IPv6 support. mongod disables IPv6 support by default.

    Setting --ipv6 does not direct the mongod to listen on any local IPv6 addresses or interfaces. To configure the mongod to listen on an IPv6 interface, you must either:

•   Configure --bind_ip with one or more IPv6 addresses or hostnames that resolve to IPv6 addresses, or

•   Set --bind_ip_all to true.

--listenBacklog <number>
    Default: Target system SOMAXCONN constant

    New in version 3.6.

    The maximum number of connections that can exist in the listen queue.

    WARNING: Consult your local system's documentation to understand the limitations and configuration requirements before using this parameter.

    IMPORTANT: To prevent undefined behavior, specify a value for this parameter between 1 and the local system SOMAXCONN constant.

    The default value for the listenBacklog parameter is set at compile time to the target system SOMAXCONN constant. SOMAXCONN is the maximum valid value that is documented for the backlog parameter to the listen system call.

    Some systems may interpret SOMAXCONN symbolically, and others numerically. The actual listen backlog applied in practice may differ from any numeric interpretation of the SOMAXCONN constant or argument to --listenBacklog, and may also be constrained by system settings like net.core.somaxconn on Linux.

    Passing a value for the listenBacklog parameter that exceeds the SOMAXCONN constant for the local system is, by the letter of the standards, undefined behavior. Higher values may be silently integer truncated, may be ignored, may cause unexpected resource consumption, or have other adverse consequences.

    On systems with workloads that exhibit connection spikes, for which it is empirically known that the local system can honor higher values for the backlog parameter than the SOMAXCONN constant, setting the listenBacklog parameter to a higher value may reduce operation latency as observed by the client by reducing the number of connections which are forced into a backoff state.

--maxConns <number>
    The maximum number of simultaneous connections that mongod will accept. This setting has no effect if it is higher than your operating system's configured maximum connection tracking threshold.

    Do not assign too low of a value to this option, or you will encounter errors during normal application operation.

--logpath <path>
    Sends all diagnostic logging information to a log file instead of to standard output or to the host's syslog system. MongoDB creates the log file at the path you specify.

    By default, MongoDB will move any existing log file rather than overwrite it. To instead append to the log file, set the --logappend option.

--syslog
    Sends all logging output to the host's syslog system rather than to standard output or to a log file (--logpath).

    The --syslog option is not supported on Windows.

    WARNING: The syslog daemon generates timestamps when it logs a message, not when MongoDB issues the message. This can lead to misleading timestamps for log entries, especially when the system is under heavy load. We recommend using the --logpath option for production systems to ensure accurate timestamps.

    Starting in version 4.2, MongoDB includes the component in its log messages to syslog.

    ...  ACCESS   [repl writer worker 5] Unsupported modification to roles collection ...

--syslogFacility <string>
    Default: user

    Specifies the facility level used when logging messages to syslog. The value you specify must be supported by your operating system's implementation of syslog. To use this option, you must enable the --syslog option.

--logappend
    Appends new entries to the end of the existing log file when the mongod instance restarts. Without this option, mongod will back up the existing log and create a new file.

--logRotate <string>
    Default: rename

    Determines the behavior for the logRotate command. Specify either rename or reopen:

•   rename renames the log file.

•   reopen closes and reopens the log file following the typical Linux/Unix log rotate behavior. Use reopen when using the Linux/Unix logrotate utility to avoid log loss.

    If you specify reopen, you must also use --logappend.

--timeStampFormat <string>
    Default: iso8601-local

    The time format for timestamps in log messages. Specify one of the following values:
    Value | Description
    iso8601-utc | Displays timestamps in Coordinated Universal Time (UTC) in the ISO-8601 format. For example, for New York at the start of the Epoch: 1970-01-01T00:00:00.000Z
    iso8601-local | Displays timestamps in local time in the ISO-8601 format. For example, for New York at the start of the Epoch: 1969-12-31T19:00:00.000-05:00

    NOTE: Starting in MongoDB 4.4, --timeStampFormat no longer supports ctime. An example of ctime formatted date is: Wed Dec 31 18:17:54.811.

--traceExceptions
    For internal diagnostic use only.

--pidfilepath <path>
    Specifies a file location to store the process ID (PID) of the mongod process. The user running the mongod or mongos process must be able to write to this path. If the --pidfilepath option is not specified, the process does not create a PID file. This option is generally only useful in combination with the --fork option.

Linux

    On Linux, PID file management is generally the responsibility of your distro's init system: usually a service file in the /etc/init.d directory, or a systemd unit file registered with systemctl. Only use the --pidfilepath option if you are not using one of these init systems. For more information, please see the respective Installation Guide for your operating system.

macOS

    On macOS, PID file management is generally handled by brew. Only use the --pidfilepath option if you are not using brew on your macOS system. For more information, please see the respective Installation Guide for your operating system.

--keyFile <file>
    Specifies the path to a key file that stores the shared secret that MongoDB instances use to authenticate to each other in a sharded cluster or replica set. --keyFile implies --auth. See inter-process-auth for more information.

    Starting in MongoDB 4.2, keyfiles for internal membership authentication use YAML format to allow for multiple keys in a keyfile. The YAML format accepts content of:

•   a single key string (same as in earlier versions),

•   multiple key strings (each string must be enclosed in quotes), or

•   sequence of key strings.

    The YAML format is compatible with the existing single-key keyfiles that use the text file format.

--setParameter <options>
    Specifies one of the MongoDB parameters described in /reference/parameters. You can specify multiple setParameter fields.

--nounixsocket
    Disables listening on the UNIX domain socket. --nounixsocket applies only to Unix-based systems.

    The mongod process always listens on the UNIX socket unless one of the following is true:

•   --nounixsocket is set

•   net.bindIp is not set

•   net.bindIp does not specify localhost or its associated IP address

    mongod installed from official .deb and .rpm packages have the bind_ip configuration set to 127.0.0.1 by default.

--unixSocketPrefix <path>
    Default: /tmp

    The path for the UNIX socket. --unixSocketPrefix applies only to Unix-based systems.

    If this option has no value, the mongod process creates a socket with /tmp as a prefix. MongoDB creates and listens on a UNIX socket unless one of the following is true:

•   net.unixDomainSocket.enabled is false

•   --nounixsocket is set

•   net.bindIp is not set

•   net.bindIp does not specify localhost or its associated IP address

--filePermissions <path>
    Default: 0700

    Sets the permission for the UNIX domain socket file.

    --filePermissions applies only to Unix-based systems.

--fork
    Enables a daemon mode that runs the mongod process in the background. By default mongod does not run as a daemon: typically you will run mongod as a daemon, either by using --fork or by using a controlling process that handles the daemonization process (e.g. as with upstart and systemd).

    The --fork option is not supported on Windows.

--auth
    Enables authorization to control user's access to database resources and operations. When authorization is enabled, MongoDB requires all clients to authenticate themselves first in order to determine the access for the client.

    Configure users via the mongo shell. If no users exist, the localhost interface will continue to have access to the database until you create the first user.

    See Security for more information.

--noauth
    Disables authentication. Currently the default. Exists for future compatibility and clarity.

--transitionToAuth
    New in version 3.4: Allows the mongod to accept and create authenticated and non-authenticated connections to and from other mongod and mongos instances in the deployment. Used for performing rolling transition of replica sets or sharded clusters from a no-auth configuration to internal authentication. Requires specifying a internal authentication mechanism such as --keyFile.

    For example, if using keyfiles for internal authentication, the mongod creates an authenticated connection with any mongod or mongos in the deployment using a matching keyfile. If the security mechanisms do not match, the mongod utilizes a non-authenticated connection instead.

    A mongod running with --transitionToAuth does not enforce user access controls. Users may connect to your deployment without any access control checks and perform read, write, and administrative operations.

    NOTE: A mongod running with internal authentication and without --transitionToAuth requires clients to connect using user access controls. Update clients to connect to the mongod using the appropriate user prior to restarting mongod without --transitionToAuth.

--cpu
    Forces the mongod process to report the percentage of CPU time in write lock, every four seconds.

--sysinfo
    Returns diagnostic system information and then exits. The information provides the page size, the number of physical pages, and the number of available physical pages.

--noscripting
    Disables the scripting engine.

--notablescan
    Forbids operations that require a collection scan. See notablescan for additional information.

--shutdown
    The --shutdown option cleanly and safely terminates the mongod process. When invoking mongod with this option you must set the --dbpath option either directly or by way of the configuration file and the --config option.

    The --shutdown option is available only on Linux systems.

    For additional ways to shut down, see also terminate-mongod-processes.

--redactClientLogData
    New in version 3.4: Available in MongoDB Enterprise only.

    A mongod running with --redactClientLogData redacts any message accompanying a given log event before logging. This prevents the mongod from writing potentially sensitive data stored on the database to the diagnostic log. Metadata such as error or operation codes, line numbers, and source file names are still visible in the logs.

    Use --redactClientLogData in conjunction with /core/security-encryption-at-rest and /core/security-transport-encryption to assist compliance with regulatory requirements.

    For example, a MongoDB deployment might store Personally Identifiable Information (PII) in one or more collections. The mongod logs events such as those related to CRUD operations, sharding metadata, etc. It is possible that the mongod may expose PII as a part of these logging operations. A mongod running with --redactClientLogData removes any message accompanying these events before being output to the log, effectively removing the PII.

    Diagnostics on a mongod running with --redactClientLogData may be more difficult due to the lack of data related to a log event. See the process logging manual page for an example of the effect of --redactClientLogData on log output.

    On a running mongod, use setParameter with the redactClientLogData parameter to configure this setting.

--networkMessageCompressors <string>
    Default: snappy,zstd,zlib

    New in version 3.4.

    Specifies the default compressor(s) to use for communication between this mongod instance and:

•   other members of the deployment if the instance is part of a replica set or a sharded cluster

•   a mongo shell

•   drivers that support the OP_COMPRESSED message format.

    MongoDB supports the following compressors:

•   snappy

•   zlib (Available starting in MongoDB 3.6)

•   zstd (Available starting in MongoDB 4.2)

    In versions 3.6 and 4.0, mongod and mongos enable network compression by default with snappy as the compressor.

    Starting in version 4.2, mongod and mongos instances default to both snappy,zstd,zlib compressors, in that order.

    To disable network compression, set the value to disabled.

    IMPORTANT: Messages are compressed when both parties enable network compression. Otherwise, messages between the parties are uncompressed.

    If you specify multiple compressors, then the order in which you list the compressors matter as well as the communication initiator. For example, if a mongo shell specifies the following network compressors zlib,snappy and the mongod specifies snappy,zlib, messages between mongo shell and mongod uses zlib.

    If the parties do not share at least one common compressor, messages between the parties are uncompressed. For example, if a mongo shell specifies the network compressor zlib and mongod specifies snappy, messages between mongo shell and mongod are not compressed.

--timeZoneInfo <path>
    The full path from which to load the time zone database. If this option is not provided, then MongoDB will use its built-in time zone database.

    The configuration file included with Linux and macOS packages sets the time zone database path to /usr/share/zoneinfo by default.

    The built-in time zone database is a copy of the Olson/IANA time zone database. It is updated along with MongoDB releases, but the release cycle of the time zone database differs from the release cycle of MongoDB. A copy of the most recent release of the time zone database can be downloaded from https://downloads.mongodb.org/olson_tz_db/timezonedb-latest.zip.

    wget https://downloads.mongodb.org/olson_tz_db/timezonedb-latest.zip
    unzip timezonedb-latest.zip
    mongod --timeZoneInfo timezonedb-2017b/

    SEE ALSO: processManagement.timeZoneInfo.

--serviceExecutor <string>
    Default: synchronous

    New in version 3.6.

    Determines the threading and execution model mongod uses to execute client requests. The --serviceExecutor option accepts one of the following values:
    Value | Description
    synchronous | The mongod uses synchronous networking and manages its networking thread pool on a per connection basis. Previous versions of MongoDB managed threads in this way.
    adaptive | The mongod uses the new experimental asynchronous networking mode with an adaptive thread pool which manages threads on a per request basis. This mode should have more consistent performance and use less resources when there are more inactive connections than database requests.

--outputConfig
    New in version 4.2.

    Outputs the mongod instance's configuration options, formatted in YAML, to stdout and exits the mongod instance. For configuration options that uses externally-sourced-values, --outputConfig returns the resolved value for those options.

    WARNING: This may include any configured passwords or secrets previously obfuscated through the external source.

    For usage examples, see:

•   expansion-directive-output

•   /tutorial/convert-command-line-options-to-yaml

  Free Monitoring

New in version 4.0.

--enableFreeMonitoring <runtime|on|off>
    New in version 4.0: Available for MongoDB Community Edition.

    Enables or disables free MongoDB Cloud monitoring. --enableFreeMonitoring accepts the following values:
    runtime | Default. You can enable or disable free monitoring during runtime. To enable or disable free monitoring during runtime, see db.enableFreeMonitoring() and db.disableFreeMonitoring(). To enable or disable free monitoring during runtime when running with access control, users must have required privileges. See db.enableFreeMonitoring() and db.disableFreeMonitoring() for details.
    on | Enables free monitoring at startup; i.e. registers for free monitoring. When enabled at startup, you cannot disable free monitoring during runtime.
    off | Disables free monitoring at startup, regardless of whether you have previously registered for free monitoring. When disabled at startup, you cannot enable free monitoring during runtime.

    Once enabled, the free monitoring state remains enabled until explicitly disabled. That is, you do not need to re-enable each time you start the server.

    For the corresponding configuration file setting, see cloud.monitoring.free.state.

--freeMonitoringTag <string>
    New in version 4.0: Available for MongoDB Community Edition.

    Optional tag to describe environment context. The tag can be sent as part of the free MongoDB Cloud monitoring registration at start up.

    For the corresponding configuration file setting, see cloud.monitoring.free.tags.

  LDAP Authentication or Authorization Options

--ldapServers <host1>:<port>,<host2>:<port>,...,<hostN>:<port>
    New in version 3.4: Available in MongoDB Enterprise only.

    The LDAP server against which the mongod authenticates users or determines what actions a user is authorized to perform on a given database. If the LDAP server specified has any replicated instances, you may specify the host and port of each replicated server in a comma-delimited list.

    If your LDAP infrastructure partitions the LDAP directory over multiple LDAP servers, specify one LDAP server or any of its replicated instances to --ldapServers. MongoDB supports following LDAP referrals as defined in RFC 4511 4.1.10. Do not use --ldapServers for listing every LDAP server in your infrastructure.

    This setting can be configured on a running mongod using setParameter.

    If unset, mongod cannot use LDAP authentication or authorization.

--ldapValidateLDAPServerConfig <boolean>
    Available in MongoDB Enterprise

    A flag that determines if the mongod instance checks the availability of the LDAP server(s) as part of its startup:

•   If true, the mongod instance performs the availability check and only continues to start up if the LDAP server is available.

•   If false, the mongod instance skips the availability check; i.e. the instance starts up even if the LDAP server is unavailable.

--ldapQueryUser <string>
    New in version 3.4: Available in MongoDB Enterprise only.

    The identity with which mongod binds as, when connecting to or performing queries on an LDAP server.

    Only required if any of the following are true:

•   Using LDAP authorization.

•   Using an LDAP query for username transformation.

•   The LDAP server disallows anonymous binds

    You must use --ldapQueryUser with --ldapQueryPassword.

    If unset, mongod will not attempt to bind to the LDAP server.

    This setting can be configured on a running mongod using setParameter.

    NOTE: Windows MongoDB deployments can use --ldapBindWithOSDefaults instead of --ldapQueryUser and --ldapQueryPassword. You cannot specify both --ldapQueryUser and --ldapBindWithOSDefaults at the same time.

--ldapQueryPassword <string>
    New in version 3.4: Available in MongoDB Enterprise only.

    The password used to bind to an LDAP server when using --ldapQueryUser. You must use --ldapQueryPassword with --ldapQueryUser.

    If unset, mongod will not attempt to bind to the LDAP server.

    This setting can be configured on a running mongod using setParameter.

    NOTE: Windows MongoDB deployments can use --ldapBindWithOSDefaults instead of --ldapQueryPassword and --ldapQueryPassword. You cannot specify both --ldapQueryPassword and --ldapBindWithOSDefaults at the same time.

--ldapBindWithOSDefaults <bool>
    Default: false

    New in version 3.4: Available in MongoDB Enterprise for the Windows platform only.

    Allows mongod to authenticate, or bind, using your Windows login credentials when connecting to the LDAP server.

    Only required if:

•   Using LDAP authorization.

•   Using an LDAP query for username transformation.

•   The LDAP server disallows anonymous binds

    Use --ldapBindWithOSDefaults to replace --ldapQueryUser and --ldapQueryPassword.

--ldapBindMethod <string>
    Default: simple

    New in version 3.4: Available in MongoDB Enterprise only.

    The method mongod uses to authenticate to an LDAP server. Use with --ldapQueryUser and --ldapQueryPassword to connect to the LDAP server.

    --ldapBindMethod supports the following values:

•   simple - mongod uses simple authentication.

•   sasl - mongod uses SASL protocol for authentication

    If you specify sasl, you can configure the available SASL mechanisms using --ldapBindSaslMechanisms. mongod defaults to using DIGEST-MD5 mechanism.

--ldapBindSaslMechanisms <string>
    Default: DIGEST-MD5

    New in version 3.4: Available in MongoDB Enterprise only.

    A comma-separated list of SASL mechanisms mongod can use when authenticating to the LDAP server. The mongod and the LDAP server must agree on at least one mechanism. The mongod dynamically loads any SASL mechanism libraries installed on the host machine at runtime.

    Install and configure the appropriate libraries for the selected SASL mechanism(s) on both the mongod host and the remote LDAP server host. Your operating system may include certain SASL libraries by default. Defer to the documentation associated with each SASL mechanism for guidance on installation and configuration.

    If using the GSSAPI SASL mechanism for use with security-kerberos, verify the following for the mongod host machine:

Linux

•   The KRB5_CLIENT_KTNAME environment variable resolves to the name of the client keytab-files for the host machine. For more on Kerberos environment variables, please defer to the Kerberos documentation.

•   The client keytab includes a kerberos-user-principal for the mongod to use when connecting to the LDAP server and execute LDAP queries.

Windows
    If connecting to an Active Directory server, the Windows Kerberos configuration automatically generates a Ticket-Granting-Ticket when the user logs onto the system. Set --ldapBindWithOSDefaults to true to allow mongod to use the generated credentials when connecting to the Active Directory server and execute queries.

    Set --ldapBindMethod to sasl to use this option.

    NOTE: For a complete list of SASL mechanisms see the IANA listing. Defer to the documentation for your LDAP or Active Directory service for identifying the SASL mechanisms compatible with the service.

    MongoDB is not a source of SASL mechanism libraries, nor is the MongoDB documentation a definitive source for installing or configuring any given SASL mechanism. For documentation and support, defer to the SASL mechanism library vendor or owner.

    For more information on SASL, defer to the following resources:

•   For Linux, please see the Cyrus SASL documentation.

•   For Windows, please see the Windows SASL documentation.

--ldapTransportSecurity <string>
    Default: tls

    New in version 3.4: Available in MongoDB Enterprise only.

    By default, mongod creates a TLS/SSL secured connection to the LDAP server.

    For Linux deployments, you must configure the appropriate TLS Options in /etc/openldap/ldap.conf file. Your operating system's package manager creates this file as part of the MongoDB Enterprise installation, via the libldap dependency. See the documentation for TLS Options in the ldap.conf OpenLDAP documentation for more complete instructions.

    For Windows deployment, you must add the LDAP server CA certificates to the Windows certificate management tool. The exact name and functionality of the tool may vary depending on operating system version. Please see the documentation for your version of Windows for more information on certificate management.

    Set --ldapTransportSecurity to none to disable TLS/SSL between mongod and the LDAP server.

    WARNING: Setting --ldapTransportSecurity to none transmits plaintext information and possibly credentials between mongod and the LDAP server.

--ldapTimeoutMS <long>
    Default: 10000

    New in version 3.4: Available in MongoDB Enterprise only.

    The amount of time in milliseconds mongod should wait for an LDAP server to respond to a request.

    Increasing the value of --ldapTimeoutMS may prevent connection failure between the MongoDB server and the LDAP server, if the source of the failure is a connection timeout. Decreasing the value of --ldapTimeoutMS reduces the time MongoDB waits for a response from the LDAP server.

    This setting can be configured on a running mongod using setParameter.

--ldapUserToDNMapping <string>
    New in version 3.4: Available in MongoDB Enterprise only.

    Maps the username provided to mongod for authentication to a LDAP Distinguished Name (DN). You may need to use --ldapUserToDNMapping to transform a username into an LDAP DN in the following scenarios:

•   Performing LDAP authentication with simple LDAP binding, where users authenticate to MongoDB with usernames that are not full LDAP DNs.

•   Using an LDAP authorization query template that requires a DN.

•   Transforming the usernames of clients authenticating to Mongo DB using different authentication mechanisms (e.g. x.509, kerberos) to a full LDAP DN for authorization.

    --ldapUserToDNMapping expects a quote-enclosed JSON-string representing an ordered array of documents. Each document contains a regular expression match and either a substitution or ldapQuery template used for transforming the incoming username.

    Each document in the array has the following form:

    {
      match: "<regex>"
      substitution: "<LDAP DN>" | ldapQuery: "<LDAP Query>"
    }
    Field | Description | Example
    match | An ECMAScript-formatted regular expression (regex) to match against a provided username. Each parenthesis-enclosed section represents a regex capture group used by substitution or ldapQuery. | "(.+)ENGINEERING" "(.+)DBA"
    substitution | An LDAP distinguished name (DN) formatting template that converts the authentication name matched by the match regex into a LDAP DN. Each curly bracket-enclosed numeric value is replaced by the corresponding regex capture group extracted from the authentication username via the match regex. The result of the substitution must be an RFC4514 escaped string. | "cn={0},ou=engineering, dc=example,dc=com"
    ldapQuery | A LDAP query formatting template that inserts the authentication name matched by the match regex into an LDAP query URI encoded respecting RFC4515 and RFC4516. Each curly bracket-enclosed numeric value is replaced by the corresponding regex capture group extracted from the authentication username via the match expression. mongod executes the query against the LDAP server to retrieve the LDAP DN for the authenticated user. mongod requires exactly one returned result for the transformation to be successful, or mongod skips this transformation. | "ou=engineering,dc=example, dc=com??one?(user={0})"

    NOTE: An explanation of RFC4514, RFC4515, RFC4516, or LDAP queries is out of scope for the MongoDB Documentation. Please review the RFC directly or use your preferred LDAP resource.

    For each document in the array, you must use either substitution or ldapQuery. You cannot specify both in the same document.

    When performing authentication or authorization, mongod steps through each document in the array in the given order, checking the authentication username against the match filter. If a match is found, mongod applies the transformation and uses the output for authenticating the user. mongod does not check the remaining documents in the array.

    If the given document does not match the provided authentication name, mongod continues through the list of documents to find additional matches. If no matches are found in any document, or the transformation the document describes fails, mongod returns an error.

    Starting in MongoDB 4.4, mongod also returns an error if one of the transformations cannot be evaluated due to networking or authentication failures to the LDAP server. mongod rejects the connection request and does not check the remaining documents in the array.

  Example

The following shows two transformation documents. The first document matches against any string ending in @ENGINEERING, placing anything preceeding the suffix into a regex capture group. The second document matches against any string ending in @DBA, placing anything preceeding the suffix into a regex capture group.

IMPORTANT: You must pass the array to --ldapUserToDNMapping as a string.

"[
   {
      match: "(.+)@ENGINEERING.EXAMPLE.COM",
      substitution: "cn={0},ou=engineering,dc=example,dc=com"
   },
   {
      match: "(.+)@DBA.EXAMPLE.COM",
      ldapQuery: "ou=dba,dc=example,dc=com??one?(user={0})"
   }
]"

A user with username alice@ENGINEERING.EXAMPLE.COM matches the first document. The regex capture group {0} corresponds to the string alice. The resulting output is the DN "cn=alice,ou=engineering,dc=example,dc=com".

A user with username bob@DBA.EXAMPLE.COM matches the second document. The regex capture group {0} corresponds to the string bob. The resulting output is the LDAP query "ou=dba,dc=example,dc=com??one?(user=bob)". mongod executes this query against the LDAP server, returning the result "cn=bob,ou=dba,dc=example,dc=com".

If --ldapUserToDNMapping is unset, mongod applies no transformations to the username when attempting to authenticate or authorize a user against the LDAP server.

This setting can be configured on a running mongod using the setParameter database command.

--ldapAuthzQueryTemplate <string>
    New in version 3.4: Available in MongoDB Enterprise only.

    A relative LDAP query URL formatted conforming to RFC4515 and RFC4516 that mongod executes to obtain the LDAP groups to which the authenticated user belongs to. The query is relative to the host or hosts specified in --ldapServers.

    In the URL, you can use the following substituion tokens:
    Substitution Token | Description
    {USER} | Substitutes the authenticated username, or the transformed username if a username mapping is specified.
    {PROVIDED_USER} | Substitutes the supplied username, i.e. before either authentication or LDAP transformation. New in version 4.2.

    When constructing the query URL, ensure that the order of LDAP parameters respects RFC4516:

    [ dn  [ ? [attributes] [ ? [scope] [ ? [filter] [ ? [Extensions] ] ] ] ] ]

    If your query includes an attribute, mongod assumes that the query retrieves a the DNs which this entity is member of.

    If your query does not include an attribute, mongod assumes the query retrieves all entities which the user is member of.

    For each LDAP DN returned by the query, mongod assigns the authorized user a corresponding role on the admin database. If a role on the on the admin database exactly matches the DN, mongod grants the user the roles and privileges assigned to that role. See the db.createRole() method for more information on creating roles.

  Example

This LDAP query returns any groups listed in the LDAP user object's memberOf attribute.

"{USER}?memberOf?base"

Your LDAP configuration may not include the memberOf attribute as part of the user schema, may possess a different attribute for reporting group membership, or may not track group membership through attributes. Configure your query with respect to your own unique LDAP configuration.

If unset, mongod cannot authorize users using LDAP.

This setting can be configured on a running mongod using the setParameter database command.

NOTE: An explanation of RFC4515, RFC4516 or LDAP queries is out of scope for the MongoDB Documentation. Please review the RFC directly or use your preferred LDAP resource.

  Storage Options

--storageEngine string
    Default: wiredTiger

    NOTE: Starting in version 4.2, MongoDB removes the deprecated MMAPv1 storage engine.

    Specifies the storage engine for the mongod database. Available values include:
    Value | Description
    wiredTiger | To specify the /core/wiredtiger.
    inMemory | To specify the /core/inmemory. New in version 3.2: Available in MongoDB Enterprise only.

    If you attempt to start a mongod with a --dbpath that contains data files produced by a storage engine other than the one specified by --storageEngine, mongod will refuse to start.

--dbpath <path>
    Default: /data/db on Linux and macOS, \data\db on Windows

    The directory where the mongod instance stores its data.

    If using the default configuration file included with a package manager installation of MongoDB, the corresponding storage.dbPath setting uses a different default.

    The files in --dbpath must correspond to the storage engine specified in --storageEngine. If the data files do not correspond to --storageEngine, mongod will refuse to start.

--directoryperdb
    Uses a separate directory to store data for each database. The directories are under the --dbpath directory, and each subdirectory name corresponds to the database name.

    Not available for mongod instances that use the in-memory storage engine.

    To change the --directoryperdb option for existing deployments:

•   For standalone instances:

1.  Use mongodump on the existing mongod instance to generate a backup.

2.  Stop the mongod instance.

3.  Add the --directoryperdb value and configure a new data directory

4.  Restart the mongod instance.

5.  Use mongorestore to populate the new data directory.

•   For replica sets:

1.  Stop a secondary member.

2.  Add the --directoryperdb value and configure a new data directory to that secondary member.

3.  Restart that secondary.

4.  Use initial sync to populate the new data directory.

5.  Update remaining secondaries in the same fashion.

6.  Step down the primary, and update the stepped-down member in the same fashion.

--syncdelay <value>
    Default: 60

    Controls how much time can pass before MongoDB flushes data to the data files via an fsync operation.

    Do not set this value on production systems. In almost every situation, you should use the default setting.

    WARNING: If you set --syncdelay to 0, MongoDB will not sync the memory mapped files to disk.

    The mongod process writes data very quickly to the journal and lazily to the data files. --syncdelay has no effect on the journal files or journaling, but if --syncdelay is set to 0 the journal will eventually consume all available disk space. If you set --syncdelay to 0 for testing purposes, you should also set --nojournal to true.

    The serverStatus command reports the background flush thread's status via the backgroundFlushing field.

    Not available for mongod instances that use the in-memory storage engine.

--upgrade
    Upgrades the on-disk data format of the files specified by the --dbpath to the latest version, if needed.

    This option only affects the operation of the mongod if the data files are in an old format.

    In most cases you should not set this value, so you can exercise the most control over your upgrade process. See the MongoDB release notes for more information about the upgrade process.

--repair
    Changed in version 4.0.3.

    Runs a repair routine on all databases for a mongod instance. The operation attempts to salvage corrupt data as well as rebuilds all the indexes. The operation discards any corrupt data that cannot be salvaged.

  Tip

If you are running with journaling enabled, there is almost never any need to run repair since the server can use the journal files to restore the data files to a clean state automatically. However, you may need to run repair in cases where you need to recover from a disk-level data corruption.

WARNING:

•   Only use mongod --repair if you have no other options. The operation removes and does not save any corrupt data during the repair process.

•   Avoid running --repair against a replica set member:

•   To repair a replica set member, if you have an intact copy of your data available (e.g. a recent backup or an intact member of the replica set), restore from that intact copy instead(see /tutorial/resync-replica-set-member).

•   If you do choose to run mongod --repair against a replica set member and the operation modifies the data or the metadata, you must still perform a full resync in order for the member to rejoin the replica set.

•   Before using --repair, make a backup copy of the dbpath directory.

•   If repair fails to complete for any reason, you must restart the instance using the --repair option.

--journal
    Enables the durability journal to ensure data files remain valid and recoverable. This option applies only when you specify the --dbpath option. mongod enables journaling by default.

    Not available for mongod instances that use the in-memory storage engine.

    If any voting member of a replica set uses the in-memory storage engine, you must set writeConcernMajorityJournalDefault to false.

    Starting in version 4.2 (and 4.0.13 and 3.6.14 ), if a replica set member uses the in-memory storage engine (voting or non-voting) but the replica set has writeConcernMajorityJournalDefault set to true, the replica set member logs a startup warning.

--nojournal
    Disables journaling. mongod enables journaling by default.

    Not available for mongod instances that use the in-memory storage engine.

    Starting in MongoDB 4.0, you cannot specify --nojournal option or storage.journal.enabled: false for replica set members that use the WiredTiger storage engine.

--journalCommitInterval <value>
    Default: 100

    The maximum amount of time in milliseconds that the mongod process allows between journal operations. Values can range from 1 to 500 milliseconds. Lower values increase the durability of the journal, at the expense of disk performance.

    On WiredTiger, the default journal commit interval is 100 milliseconds. Additionally, a write that includes or implies j:true will cause an immediate sync of the journal. For details or additional conditions that affect the frequency of the sync, see journal-process.

    Not available for mongod instances that use the in-memory storage engine.

    NOTE: Known Issue in 4.2.0: The --journalCommitInterval is missing in 4.2.0.

  WiredTiger Options

--wiredTigerCacheSizeGB <float>
    Defines the maximum size of the internal cache that WiredTiger will use for all data. The memory consumed by an index build (see maxIndexBuildMemoryUsageMegabytes) is separate from the WiredTiger cache memory.

    Values can range from 0.25 GB to 10000 GB.

    Starting in MongoDB 3.4, the default WiredTiger internal cache size is the larger of either:

•   50% of (RAM - 1 GB), or

•   256 MB.

    For example, on a system with a total of 4GB of RAM the WiredTiger cache will use 1.5GB of RAM (0.5 * (4 GB - 1 GB) = 1.5 GB). Conversely, a system with a total of 1.25 GB of RAM will allocate 256 MB to the WiredTiger cache because that is more than half of the total RAM minus one gigabyte (0.5 * (1.25 GB - 1 GB) = 128 MB < 256 MB).

    NOTE: In some instances, such as when running in a container, the database can have memory constraints that are lower than the total system memory. In such instances, this memory limit, rather than the total system memory, is used as the maximum RAM available.

    To see the memory limit, see hostInfo.system.memLimitMB.

    Avoid increasing the WiredTiger internal cache size above its default value.

    With WiredTiger, MongoDB utilizes both the WiredTiger internal cache and the filesystem cache.

    Via the filesystem cache, MongoDB automatically uses all free memory that is not used by the WiredTiger cache or by other processes.

    NOTE: The --wiredTigerCacheSizeGB limits the size of the WiredTiger internal cache. The operating system will use the available free memory for filesystem cache, which allows the compressed MongoDB data files to stay in memory. In addition, the operating system will use any free RAM to buffer file system blocks and file system cache.

    To accommodate the additional consumers of RAM, you may have to decrease WiredTiger internal cache size.

    The default WiredTiger internal cache size value assumes that there is a single mongod instance per machine. If a single machine contains multiple MongoDB instances, then you should decrease the setting to accommodate the other mongod instances.

    If you run mongod in a container (e.g. lxc, cgroups, Docker, etc.) that does not have access to all of the RAM available in a system, you must set --wiredTigerCacheSizeGB to a value less than the amount of RAM available in the container. The exact amount depends on the other processes running in the container. See memLimitMB.

--wiredTigerMaxCacheOverflowFileSizeGB <float>

Deprecated in MongoDB 4.4

    MongoDB deprecates the --wiredTigerMaxCacheOverflowFileSizeGB option. The option has no effect starting in MongoDB 4.4.

    Specifies the maximum size (in GB) for the "lookaside (or cache overflow) table" file WiredTigerLAS.wt for MongoDB 4.2.1-4.2.x and 4.0.12-4.0.x. The file no longer exists starting in version 4.4.

    The setting can accept the following values:
    Value | Description
    0 | The default value. If set to 0, the file size is unbounded.
    number >= 0.1 | The maximum size (in GB). If the WiredTigerLAS.wt file exceeds this size, mongod exits with a fatal assertion. You can clear the WiredTigerLAS.wt file and restart mongod.

    To change the maximum size during runtime, use the wiredTigerMaxCacheOverflowSizeGB parameter.

    Available starting in MongoDB 4.2.1 (and 4.0.12)

--wiredTigerJournalCompressor <compressor>
    Default: snappy

    Specifies the type of compression to use to compress WiredTiger journal data.

    Available compressors are:

•   none

•   snappy

•   zlib

•   zstd (Available starting in MongoDB 4.2)

--wiredTigerDirectoryForIndexes
    When you start mongod with --wiredTigerDirectoryForIndexes, mongod stores indexes and collections in separate subdirectories under the data (i.e. --dbpath) directory. Specifically, mongod stores the indexes in a subdirectory named index and the collection data in a subdirectory named collection.

    By using a symbolic link, you can specify a different location for the indexes. Specifically, when mongod instance is not running, move the index subdirectory to the destination and create a symbolic link named index under the data directory to the new destination.

--wiredTigerCollectionBlockCompressor <compressor>
    Default: snappy

    Specifies the default compression for collection data. You can override this on a per-collection basis when creating collections.

    Available compressors are:

•   none

•   snappy

•   zlib

•   zstd (Available starting MongoDB 4.2)

    --wiredTigerCollectionBlockCompressor affects all collections created. If you change the value of --wiredTigerCollectionBlockCompressor on an existing MongoDB deployment, all new collections will use the specified compressor. Existing collections will continue to use the compressor specified when they were created, or the default compressor at that time.

--wiredTigerIndexPrefixCompression <boolean>
    Default: true

    Enables or disables prefix compression for index data.

    Specify true for --wiredTigerIndexPrefixCompression to enable prefix compression for index data, or false to disable prefix compression for index data.

    The --wiredTigerIndexPrefixCompression setting affects all indexes created. If you change the value of --wiredTigerIndexPrefixCompression on an existing MongoDB deployment, all new indexes will use prefix compression. Existing indexes are not affected.

  Replication Options

--replSet <setname>
    Configures replication. Specify a replica set name as an argument to this set. All hosts in the replica set must have the same set name.

    Starting in MongoDB 4.0,

•   For the WiredTiger storage engine, --replSet cannot be used in conjunction with --nojournal.

    If your application connects to more than one replica set, each set should have a distinct name. Some drivers group replica set connections by replica set name.

--oplogSize <value>
    Specifies a maximum size in megabytes for the replication operation log (i.e., the oplog).

    NOTE: Starting in MongoDB 4.0, the oplog can grow past its configured size limit to avoid deleting the majority commit point.

    By default, the mongod process creates an oplog based on the maximum amount of space available. For 64-bit systems, the oplog is typically 5% of available disk space.

    Once the mongod has created the oplog for the first time, changing the --oplogSize option will not affect the size of the oplog. To change the minimum oplog retention period after starting the mongod, use replSetResizeOplog. replSetResizeOplog enables you to resize the oplog dynamically without restarting the mongod process. To persist the changes made using replSetResizeOplog through a restart, update the value of --oplogSize.

    See replica-set-oplog-sizing for more information.

--oplogMinRetentionHours <value>
    New in version 4.4: Specifies the minimum number of hours to preserve an oplog entry, where the decimal values represent the fractions of an hour. For example, a value of 1.5 represents one hour and thirty minutes.

    The value must be greater than or equal to 0. A value of 0 indicates that the mongod should truncate the oplog starting with the oldest entries to maintain the configured maximum oplog size.

    Defaults to 0.

    A mongod started with --oplogMinRetentionHours only removes an oplog entry if:

•   The oplog has reached the maximum configured oplog size and

•   The oplog entry is older than the configured number of hours based on the host system clock.

    The mongod has the following behavior when configured with a minimum oplog retention period:

•   The oplog can grow without constraint so as to retain oplog entries for the configured number of hours. This may result in reduction or exhaustion of system disk space due to a combination of high write volume and large retention period.

•   If the oplog grows beyond its maximum size, the mongod may continue to hold that disk space even if the oplog returns to its maximum size or is configured for a smaller maximum size. See replSetResizeOplog-cmd-compact.

•   The mongod compares the system wall clock to an oplog entries creation wall clock time when enforcing oplog entry retention. Clock drift between cluster components may result in unexpected oplog retention behavior. See production-notes-clock-synchronization for more information on clock synchronization across cluster members.

    To change the minimum oplog retention period after starting the mongod, use replSetResizeOplog. replSetResizeOplog enables you to resize the oplog dynamically without restarting the mongod process. To persist the changes made using replSetResizeOplog through a restart, update the value of --oplogMinRetentionHours.

--enableMajorityReadConcern
    Default: true

    Starting in MongoDB 3.6, MongoDB enables support for "majority" read concern by default.

    You can disable read concern "majority" to prevent the storage cache pressure from immobilizing a deployment with a three-member primary-secondary-arbiter (PSA) architecture. For more information about disabling read concern "majority", see disable-read-concern-majority.

    To disable, set --enableMajorityReadConcern to false. --enableMajorityReadConcern has no effect for MongoDB versions: 4.0.0, 4.0.1, 4.0.2, 3.6.0.

    IMPORTANT: In general, avoid disabling "majority" read concern unless necessary. However, if you have a three-member replica set with a primary-secondary-arbiter (PSA) architecture or a sharded cluster with a three-member PSA shards, disable to prevent the storage cache pressure from immobilizing the deployment.

    Disabling "majority" read concern affects support for transactions on sharded clusters. Specifically:

•   A transaction cannot use read concern "snapshot" if the transaction involves a shard that has disabled read concern "majority".

•   A transaction that writes to multiple shards errors if any of the transaction's read or write operations involves a shard that has disabled read concern "majority".

    However, it does not affect transactions on replica sets. For transactions on replica sets, you can specify read concern "majority" (or "snapshot" or "local" ) for multi-document transactions even if read concern "majority" is disabled.

    Disabling "majority" read concern disables support for /changeStreams for MongoDB 4.0 and earlier. For MongoDB 4.2+, disabling read concern "majority" has no effect on change streams availability.

  Sharded Cluster Options

--configsvr
    Required if starting a config server.

    Declares that this mongod instance serves as the config server of a sharded cluster. When running with this option, clients (i.e. other cluster components) cannot write data to any database other than config and admin. The default port for a mongod with this option is 27019 and the default --dbpath directory is /data/configdb, unless specified.

    IMPORTANT: Starting in 3.4, you must deploy config servers as a replica set. The use of the deprecated mirrored mongod instances as config servers (SCCC) is no longer supported.

    The replica set config servers (CSRS) must run the WiredTiger storage engine.

    The --configsvr option creates a local oplog.

    Do not use the --configsvr option with --shardsvr. Config servers cannot be a shard server.

    Do not use the --configsvr with the skipShardingConfigurationChecks parameter. That is, if you are temporarily starting the mongod as a standalone for maintenance operations, include the parameter skipShardingConfigurationChecks and exclude --configsvr. Once maintenance has completed, remove the skipShardingConfigurationChecks parameter and restart with --configsvr.

--configsvrMode <string>
    Available in MongoDB 3.2 version only

    If set to sccc, indicates that the config servers are deployed as three mirrored mongod instances, even if one or more config servers is also a member of a replica set. configsvrMode only accepts the value sccc.

    If unset, config servers running as replica sets expect to use the "config server replica set" protocol for writing to config servers, rather than the "mirrored mongod" write protocol.

--shardsvr
    Required if starting a shard server.

    Configures this mongod instance as a shard in a sharded cluster. The default port for these instances is 27018.

    IMPORTANT: Starting in MongoDB 3.6, you must deploy shards as replica sets. See the --replSet option to deploy mongod as part of a replica set.

    Do not use the --shardsvr with the skipShardingConfigurationChecks parameter. That is, if you are temporarily starting the mongod as a standalone for maintenance operations, include the parameter skipShardingConfigurationChecks and exclude --shardsvr. Once maintenance has completed, remove the skipShardingConfigurationChecks parameter and restart with --shardsvr.

--moveParanoia
    If specified, during chunk migration, a shard saves, to the moveChunk directory of the --dbpath, all documents migrated from that shard.

    MongoDB does not automatically delete the data saved in the moveChunk directory.

--noMoveParanoia
    Changed in version 3.2: Starting in 3.2, MongoDB uses --noMoveParanoia as the default.

    During chunk migration, a shard does not save documents migrated from the shard.

  TLS Options

  See

/tutorial/configure-ssl for full documentation of MongoDB's support.

--tlsMode <mode>
    New in version 4.2.

    Enables TLS used for all network connections. The argument to the --tlsMode option can be one of the following:
    Value | Description
    disabled | The server does not use TLS.
    allowTLS | Connections between servers do not use TLS. For incoming connections, the server accepts both TLS and non-TLS.
    preferTLS | Connections between servers use TLS. For incoming connections, the server accepts both TLS and non-TLS.
    requireTLS | The server uses and accepts only TLS encrypted connections.

    If --tlsCAFile or tls.CAFile is not specified and you are not using x.509 authentication, the system-wide CA certificate store will be used when connecting to an TLS-enabled server.

    If using x.509 authentication, --tlsCAFile or tls.CAFile must be specified unless using --tlsCertificateSelector.

    For more information about TLS and MongoDB, see /tutorial/configure-ssl and /tutorial/configure-ssl-clients .

--tlsCertificateKeyFile <filename>
    New in version 4.2: Specifies the .pem file that contains both the TLS certificate and key.

    Starting with MongoDB 4.0 on macOS or Windows, you can use the --tlsCertificateSelector option to specify a certificate from the operating system's secure certificate store instead of a PEM key file. --tlsCertificateKeyFile and --tlsCertificateSelector options are mutually exclusive. You can only specify one.

•   On Linux/BSD, you must specify --tlsCertificateKeyFile when TLS/SSL is enabled.

•   On Windows or macOS, you must specify either --tlsCertificateKeyFile or --tlsCertificateSelector when TLS/SSL is enabled.

    IMPORTANT: For Windows only, MongoDB 4.0 and later do not support encrypted PEM files. The mongod fails to start if it encounters an encrypted PEM file. To securely store and access a certificate for use with TLS on Windows, use --tlsCertificateSelector.

    For more information about TLS and MongoDB, see /tutorial/configure-ssl and /tutorial/configure-ssl-clients .

--tlsCertificateKeyFilePassword <value>
    New in version 4.2.

    Specifies the password to de-crypt the certificate-key file (i.e. --tlsCertificateKeyFile). Use the --tlsCertificateKeyFilePassword option only if the certificate-key file is encrypted. In all cases, the mongod will redact the password from all logging and reporting output.

    Starting in MongoDB 4.0:

•   On Linux/BSD, if the private key in the PEM file is encrypted and you do not specify the --tlsCertificateKeyFilePassword option, MongoDB will prompt for a passphrase. See ssl-certificate-password.

•   On macOS, if the private key in the PEM file is encrypted, you must explicitly specify the --tlsCertificateKeyFilePassword option. Alternatively, you can use a certificate from the secure system store (see --tlsCertificateSelector) instead of a PEM file or use an unencrypted PEM file.

•   On Windows, MongoDB does not support encrypted certificates. The mongod fails if it encounters an encrypted PEM file. Use --tlsCertificateSelector instead.

    For more information about TLS and MongoDB, see /tutorial/configure-ssl and /tutorial/configure-ssl-clients .

--clusterAuthMode <option>
    Default: keyFile

    The authentication mode used for cluster authentication. If you use internal x.509 authentication, specify so here. This option can have one of the following values:
    Value | Description
    keyFile | Use a keyfile for authentication. Accept only keyfiles.
    sendKeyFile | For rolling upgrade purposes. Send a keyfile for authentication but can accept both keyfiles and x.509 certificates.
    sendX509 | For rolling upgrade purposes. Send the x.509 certificate for authentication but can accept both keyfiles and x.509 certificates.
    x509 | Recommended. Send the x.509 certificate for authentication and accept only x.509 certificates.

    If --tlsCAFile or tls.CAFile is not specified and you are not using x.509 authentication, the system-wide CA certificate store will be used when connecting to an TLS-enabled server.

    If using x.509 authentication, --tlsCAFile or tls.CAFile must be specified unless using --tlsCertificateSelector.

    For more information about TLS and MongoDB, see /tutorial/configure-ssl and /tutorial/configure-ssl-clients .

--tlsClusterFile <filename>
    New in version 4.2: Specifies the .pem file that contains the x.509 certificate-key file for membership authentication for the cluster or replica set.

    Starting with MongoDB 4.0 on macOS or Windows, you can use the --tlsClusterCertificateSelector option to specify a certificate from the operating system's secure certificate store instead of a PEM key file. --tlsClusterFile and --tlsClusterCertificateSelector options are mutually exclusive. You can only specify one.

    If --tlsClusterFile does not specify the .pem file for internal cluster authentication or the alternative --tlsClusterCertificateSelector, the cluster uses the .pem file specified in the --tlsCertificateKeyFile option or the certificate returned by the --tlsCertificateSelector.

    If using x.509 authentication, --tlsCAFile or tls.CAFile must be specified unless using --tlsCertificateSelector.

    Changed in version 4.4: mongod / mongos logs a warning on connection if the presented x.509 certificate expires within 30 days of the mongod/mongos host system time. See 4.4-rel-notes-certificate-expiration-warning for more information.

    For more information about TLS and MongoDB, see /tutorial/configure-ssl and /tutorial/configure-ssl-clients .

    IMPORTANT: For Windows only, MongoDB 4.0 and later do not support encrypted PEM files. The mongod fails to start if it encounters an encrypted PEM file. To securely store and access a certificate for use with membership authentication on Windows, use --tlsClusterCertificateSelector.

--tlsCertificateSelector <parameter>=<value>
    New in version 4.2: Available on Windows and macOS as an alternative to --tlsCertificateKeyFile. In version 4.0, see --sslCertificateSelector.

    Specifies a certificate property in order to select a matching certificate from the operating system's certificate store to use for TLS.

    The --tlsCertificateKeyFile and --tlsCertificateSelector options are mutually exclusive. You can only specify one.

    --tlsCertificateSelector accepts an argument of the format <property>=<value> where the property can be one of the following:
    Property | Value type | Description
    subject | ASCII string | Subject name or common name on certificate
    thumbprint | hex string | A sequence of bytes, expressed as hexadecimal, used to identify a public key by its SHA-1 digest. The thumbprint is sometimes referred to as a fingerprint.

    When using the system SSL certificate store, OCSP (Online Certificate Status Protocol) is used to validate the revocation status of certificates.

    The mongod searches the operating system's secure certificate store for the CA certificates required to validate the full certificate chain of the specified TLS certificate. Specifically, the secure certificate store must contain the root CA and any intermediate CA certificates required to build the full certificate chain to the TLS certificate. Do not use --tlsCAFile or --tlsClusterCAFile to specify the root and intermediate CA certificate

    For example, if the TLS/SSL certificate was signed with a single root CA certificate, the secure certificate store must contain that root CA certificate. If the TLS/SSL certificate was signed with an intermediate CA certificate, the secure certificate store must contain the intermedia CA certificate and the root CA certificate.

--tlsClusterCertificateSelector <parameter>=<value>
    New in version 4.2: Available on Windows and macOS as an alternative to --tlsClusterFile.

    Specifies a certificate property in order to select a matching certificate from the operating system's certificate store to use for internal x.509 membership authentication.

    --tlsClusterFile and --tlsClusterCertificateSelector options are mutually exclusive. You can only specify one.

    --tlsClusterCertificateSelector accepts an argument of the format <property>=<value> where the property can be one of the following:
    Property | Value type | Description
    subject | ASCII string | Subject name or common name on certificate
    thumbprint | hex string | A sequence of bytes, expressed as hexadecimal, used to identify a public key by its SHA-1 digest. The thumbprint is sometimes referred to as a fingerprint.

    The mongod searches the operating system's secure certificate store for the CA certificates required to validate the full certificate chain of the specified cluster certificate. Specifically, the secure certificate store must contain the root CA and any intermediate CA certificates required to build the full certificate chain to the cluster certificate. Do not use --tlsCAFile or --tlsClusterCAFile to specify the root and intermediate CA certificate.

    For example, if the cluster certificate was signed with a single root CA certificate, the secure certificate store must contain that root CA certificate. If the cluster certificate was signed with an intermediate CA certificate, the secure certificate store must contain the intermedia CA certificate and the root CA certificate.

    Changed in version 4.4: mongod / mongos logs a warning on connection if the presented x.509 certificate expires within 30 days of the mongod/mongos host system time. See 4.4-rel-notes-certificate-expiration-warning for more information.

--tlsClusterPassword <value>
    New in version 4.2: Specifies the password to de-crypt the x.509 certificate-key file specified with --tlsClusterFile. Use the --tlsClusterPassword option only if the certificate-key file is encrypted. In all cases, the mongod will redact the password from all logging and reporting output.

    Starting in MongoDB 4.0:

•   On Linux/BSD, if the private key in the x.509 file is encrypted and you do not specify the --tlsClusterPassword option, MongoDB will prompt for a passphrase. See ssl-certificate-password.

•   On macOS, if the private key in the x.509 file is encrypted, you must explicitly specify the --tlsClusterPassword option. Alternatively, you can either use a certificate from the secure system store (see --tlsClusterCertificateSelector) instead of a cluster PEM file or use an unencrypted PEM file.

•   On Windows, MongoDB does not support encrypted certificates. The mongod fails if it encounters an encrypted PEM file. Use --tlsClusterCertificateSelector instead.

    For more information about TLS and MongoDB, see /tutorial/configure-ssl and /tutorial/configure-ssl-clients .

--tlsCAFile <filename>
    New in version 4.2.

    Specifies the .pem file that contains the root certificate chain from the Certificate Authority. Specify the file name of the .pem file using relative or absolute paths.

Windows/macOS Only
    If using --tlsCertificateSelector and/or --tlsClusterCertificateSelector, do not use --tlsCAFile to specify the root and intermediate CA certificates. Store all CA certificates required to validate the full trust chain of the --tlsCertificateSelector and/or --tlsClusterCertificateSelector certificates in the secure certificate store.

    For more information about TLS and MongoDB, see /tutorial/configure-ssl and /tutorial/configure-ssl-clients .

--tlsClusterCAFile <filename>
    New in version 4.2.

    Specifies the .pem file that contains the root certificate chain from the Certificate Authority used to validate the certificate presented by a client establishing a connection. Specify the file name of the .pem file using relative or absolute paths. --tlsClusterCAFile requires that --tlsCAFile is set.

    If --tlsClusterCAFile does not specify the .pem file for validating the certificate from a client establishing a connection, the cluster uses the .pem file specified in the --tlsCAFile option.

    --tlsClusterCAFile lets you use separate Certificate Authorities to verify the client to server and server to client portions of the TLS handshake.

Windows/macOS Only
    If using --tlsCertificateSelector and/or --tlsClusterCertificateSelector, do not use --tlsClusterCAFile to specify the root and intermediate CA certificates. Store all CA certificates required to validate the full trust chain of the --tlsCertificateSelector and/or --tlsClusterCertificateSelector certificates in the secure certificate store.

    For more information about TLS and MongoDB, see /tutorial/configure-ssl and /tutorial/configure-ssl-clients .

--tlsCRLFile <filename>
    New in version 4.2: For MongoDB 4.0 and earlier, see --sslCRLFile.

    Specifies the .pem file that contains the Certificate Revocation List. Specify the file name of the .pem file using relative or absolute paths.

    NOTE:

•   Starting in MongoDB 4.0, you cannot specify a CRL file on macOS. Instead, you can use the system SSL certificate store, which uses OCSP (Online Certificate Status Protocol) to validate the revocation status of certificates. See --sslCertificateSelector in MongoDB 4.0 and --tlsCertificateSelector in MongoDB 4.2+ to use the system SSL certificate store.

•   Starting in version 4.4, to check for certificate revocation, MongoDB enables the use of OCSP (Online Certificate Status Protocol) by default as an alternative to specifying a CRL file or using the system SSL certificate store.

    For more information about TLS and MongoDB, see /tutorial/configure-ssl and /tutorial/configure-ssl-clients .

--tlsAllowInvalidCertificates
    New in version 4.2.

    Bypasses the validation checks for TLS certificates on other servers in the cluster and allows the use of invalid certificates to connect.

    NOTE: If you specify --tlsAllowInvalidCertificates or tls.allowInvalidCertificates: true when using x.509 authentication, an invalid certificate is only sufficient to establish a TLS connection but is insufficient for authentication.

    When using the --tlsAllowInvalidCertificates setting, MongoDB logs a warning regarding the use of the invalid certificate.

    For more information about TLS and MongoDB, see /tutorial/configure-ssl and /tutorial/configure-ssl-clients .

--tlsAllowInvalidHostnames
    New in version 4.2.

    Disables the validation of the hostnames in TLS certificates, when connecting to other members of the replica set or sharded cluster for inter-process authentication. This allows mongod to connect to other members if the hostnames in their certificates do not match their configured hostname.

    For more information about TLS and MongoDB, see /tutorial/configure-ssl and /tutorial/configure-ssl-clients .

--tlsAllowConnectionsWithoutCertificates
    New in version 4.2.

    For clients that do not present certificates, mongod bypasses TLS/SSL certificate validation when establishing the connection.

    For clients that present a certificate, however, mongod performs certificate validation using the root certificate chain specified by --tlsCAFile and reject clients with invalid certificates.

    Use the --tlsAllowConnectionsWithoutCertificates option if you have a mixed deployment that includes clients that do not or cannot present certificates to the mongod.

    For more information about TLS and MongoDB, see /tutorial/configure-ssl and /tutorial/configure-ssl-clients .

--tlsDisabledProtocols <protocol(s)>
    New in version 4.2.

    Prevents a MongoDB server running with TLS from accepting incoming connections that use a specific protocol or protocols. To specify multiple protocols, use a comma separated list of protocols.

    --tlsDisabledProtocols recognizes the following protocols: TLS1_0, TLS1_1, TLS1_2, and TLS1_3.

•   On macOS, you cannot disable TLS1_1 and leave both TLS1_0 and TLS1_2 enabled. You must disable at least one of the other two, for example, TLS1_0,TLS1_1.

•   To list multiple protocols, specify as a comma separated list of protocols. For example TLS1_0,TLS1_1.

•   Specifying an unrecognized protocol will prevent the server from starting.

•   The specified disabled protocols overrides any default disabled protocols.

    Starting in version 4.0, MongoDB disables the use of TLS 1.0 if TLS 1.1+ is available on the system. To enable the disabled TLS 1.0, specify none to --tlsDisabledProtocols. See 4.0-disable-tls.

    Members of replica sets and sharded clusters must speak at least one protocol in common.

    SEE ALSO: ssl-disallow-protocols

--tlsFIPSMode
    New in version 4.2.

    Directs the mongod to use the FIPS mode of the TLS library. Your system must have a FIPS compliant library to use the --tlsFIPSMode option.

    NOTE: FIPS-compatible TLS/SSL is available only in MongoDB Enterprise. See /tutorial/configure-fips for more information.

  SSL Options (Deprecated)

IMPORTANT: All SSL options are deprecated since 4.2. Use the TLS counterparts instead, as they have identical functionality to the SSL options. The SSL protocol is deprecated and MongoDB supports TLS 1.0 and later.

  See

/tutorial/configure-ssl for full documentation of MongoDB's support.

--sslOnNormalPorts
    Deprecated since version 2.6: Use --tlsMode requireTLS instead.

    Enables TLS/SSL for mongod.

    With --sslOnNormalPorts, a mongod requires TLS/SSL encryption for all connections on the default MongoDB port, or the port specified by --port. By default, --sslOnNormalPorts is disabled.

    For more information about TLS/SSL and MongoDB, see /tutorial/configure-ssl and /tutorial/configure-ssl-clients .

--sslMode <mode>
    Deprecated since version 4.2: Use --tlsMode instead.

    Enables TLS/SSL or mixed TLS/SSL used for all network connections. The argument to the --sslMode option can be one of the following:
    Value | Description
    disabled | The server does not use TLS/SSL.
    allowSSL | Connections between servers do not use TLS/SSL. For incoming connections, the server accepts both TLS/SSL and non-TLS/non-SSL.
    preferSSL | Connections between servers use TLS/SSL. For incoming connections, the server accepts both TLS/SSL and non-TLS/non-SSL.
    requireSSL | The server uses and accepts only TLS/SSL encrypted connections.

    Starting in version 3.4, if --tlsCAFile/net.tls.CAFile (or their aliases --sslCAFile/net.ssl.CAFile) is not specified and you are not using x.509 authentication, the system-wide CA certificate store will be used when connecting to an TLS/SSL-enabled server.

    To use x.509 authentication, --tlsCAFile or net.tls.CAFile must be specified unless using --tlsCertificateSelector or --net.tls.certificateSelector. Or if using the ssl aliases, --sslCAFile or net.ssl.CAFile must be specified unless using --sslCertificateSelector or net.ssl.certificateSelector.

    For more information about TLS/SSL and MongoDB, see /tutorial/configure-ssl and /tutorial/configure-ssl-clients .

--sslPEMKeyFile <filename>
    Deprecated since version 4.2: Use --tlsCertificateKeyFile instead.

    Specifies the .pem file that contains both the TLS/SSL certificate and key.

    Starting with MongoDB 4.0 on macOS or Windows, you can use the --sslCertificateSelector option to specify a certificate from the operating system's secure certificate store instead of a PEM key file. --sslPEMKeyFile and --sslCertificateSelector options are mutually exclusive. You can only specify one.

•   On Linux/BSD, you must specify --sslPEMKeyFile when TLS/SSL is enabled.

•   On Windows or macOS, you must specify either --sslPEMKeyFile or --sslCertificateSelector when TLS/SSL is enabled.

    IMPORTANT: For Windows only, MongoDB 4.0 and later do not support encrypted PEM files. The mongod fails to start if it encounters an encrypted PEM file. To securely store and access a certificate for use with TLS/SSL on Windows, use --sslCertificateSelector.

    For more information about TLS/SSL and MongoDB, see /tutorial/configure-ssl and /tutorial/configure-ssl-clients .

--sslPEMKeyPassword <value>
    Deprecated since version 4.2: Use --tlsCertificateKeyFilePassword instead.

    Specifies the password to de-crypt the certificate-key file (i.e. --sslPEMKeyFile). Use the --sslPEMKeyPassword option only if the certificate-key file is encrypted. In all cases, the mongod will redact the password from all logging and reporting output.

    Starting in MongoDB 4.0:

•   On Linux/BSD, if the private key in the PEM file is encrypted and you do not specify the --sslPEMKeyPassword option, MongoDB will prompt for a passphrase. See ssl-certificate-password.

•   On macOS, if the private key in the PEM file is encrypted, you must explicitly specify the --sslPEMKeyPassword option. Alternatively, you can use a certificate from the secure system store (see --sslCertificateSelector) instead of a PEM key file or use an unencrypted PEM file.

•   On Windows, MongoDB does not support encrypted certificates. The mongod fails if it encounters an encrypted PEM file. Use --sslCertificateSelector instead.

    For more information about TLS/SSL and MongoDB, see /tutorial/configure-ssl and /tutorial/configure-ssl-clients .

--sslClusterFile <filename>
    Deprecated since version 4.2: Use --tlsClusterFile instead.

    Specifies the .pem file that contains the x.509 certificate-key file for membership authentication for the cluster or replica set.

    Starting with MongoDB 4.0 on macOS or Windows, you can use the --sslClusterCertificateSelector option to specify a certificate from the operating system's secure certificate store instead of a PEM key file. --sslClusterFile and --sslClusterCertificateSelector options are mutually exclusive. You can only specify one.

    If --sslClusterFile does not specify the .pem file for internal cluster authentication or the alternative --sslClusterCertificateSelector, the cluster uses the .pem file specified in the --sslPEMKeyFile option or the certificate returned by the --sslCertificateSelector.

    To use x.509 authentication, --tlsCAFile or net.tls.CAFile must be specified unless using --tlsCertificateSelector or --net.tls.certificateSelector. Or if using the ssl aliases, --sslCAFile or net.ssl.CAFile must be specified unless using --sslCertificateSelector or net.ssl.certificateSelector.

    For more information about TLS/SSL and MongoDB, see /tutorial/configure-ssl and /tutorial/configure-ssl-clients .

    IMPORTANT: For Windows only, MongoDB 4.0 and later do not support encrypted PEM files. The mongod fails to start if it encounters an encrypted PEM file. To securely store and access a certificate for use with membership authentication on Windows, use --sslClusterCertificateSelector.

--sslCertificateSelector <parameter>=<value>
    Deprecated since version 4.2: Use --tlsCertificateSelector instead.

    New in version 4.0: Available on Windows and macOS as an alternative to --tlsCertificateKeyFile.

    Specifies a certificate property to select a matching certificate from the operating system's secure certificate store to use for TLS/SSL.

    --sslPEMKeyFile and --sslCertificateSelector options are mutually exclusive. You can only specify one.

    --sslCertificateSelector accepts an argument of the format <property>=<value> where the property can be one of the following:
    Property | Value type | Description
    subject | ASCII string | Subject name or common name on certificate
    thumbprint | hex string | A sequence of bytes, expressed as hexadecimal, used to identify a public key by its SHA-1 digest. The thumbprint is sometimes referred to as a fingerprint.

    When using the system SSL certificate store, OCSP (Online Certificate Status Protocol) is used to validate the revocation status of certificates.

    The mongod searches the operating system's secure certificate store for the CA certificates required to validate the full certificate chain of the specified TLS/SSL certificate. Specifically, the secure certificate store must contain the root CA and any intermediate CA certificates required to build the full certificate chain to the TLS/SSL certificate. Do not use --sslCAFile or --sslClusterCAFile to specify the root and intermediate CA certificate

    For example, if the TLS/SSL certificate was signed with a single root CA certificate, the secure certificate store must contain that root CA certificate. If the TLS/SSL certificate was signed with an intermediate CA certificate, the secure certificate store must contain the intermedia CA certificate and the root CA certificate.

--sslClusterCertificateSelector <parameter>=<value>
    Deprecated since version 4.2: Use --tlsClusterCertificateSelector instead.

    New in version 4.0: Available on Windows and macOS as an alternative to --sslClusterFile.

    Specifies a certificate property to select a matching certificate from the operating system's secure certificate store to use for internal x.509 membership authentication.

    --sslClusterFile and --sslClusterCertificateSelector options are mutually exclusive. You can only specify one.

    --sslClusterCertificateSelector accepts an argument of the format <property>=<value> where the property can be one of the following:
    Property | Value type | Description
    subject | ASCII string | Subject name or common name on certificate
    thumbprint | hex string | A sequence of bytes, expressed as hexadecimal, used to identify a public key by its SHA-1 digest. The thumbprint is sometimes referred to as a fingerprint.

    The mongod searches the operating system's secure certificate store for the CA certificates required to validate the full certificate chain of the specified cluster certificate. Specifically, the secure certificate store must contain the root CA and any intermediate CA certificates required to build the full certificate chain to the cluster certificate. Do not use --sslCAFile or --sslClusterCAFile to specify the root and intermediate CA certificate.

    For example, if the cluster certificate was signed with a single root CA certificate, the secure certificate store must contain that root CA certificate. If the cluster certificate was signed with an intermediate CA certificate, the secure certificate store must contain the intermedia CA certificate and the root CA certificate.

--sslClusterPassword <value>
    Deprecated since version 4.2: Use --tlsClusterPassword instead.

    Specifies the password to de-crypt the x.509 certificate-key file specified with --sslClusterFile. Use the --sslClusterPassword option only if the certificate-key file is encrypted. In all cases, the mongod will redact the password from all logging and reporting output.

    Starting in MongoDB 4.0:

•   On Linux/BSD, if the private key in the x.509 file is encrypted and you do not specify the --sslClusterPassword option, MongoDB will prompt for a passphrase. See ssl-certificate-password.

•   On macOS, if the private key in the x.509 file is encrypted, you must explicitly specify the --sslClusterPassword option. Alternatively, you can either use a certificate from the secure system store (see --sslClusterCertificateSelector) instead of a cluster PEM file or use an unencrypted PEM file.

•   On Windows, MongoDB does not support encrypted certificates. The mongod fails if it encounters an encrypted PEM file. Use --sslClusterCertificateSelector instead.

    For more information about TLS/SSL and MongoDB, see /tutorial/configure-ssl and /tutorial/configure-ssl-clients .

--sslCAFile <filename>
    Deprecated since version 4.2: Use --tlsCAFile instead.

    Specifies the .pem file that contains the root certificate chain from the Certificate Authority. Specify the file name of the .pem file using relative or absolute paths.

Windows/macOS Only
    If using --sslCertificateSelector and/or --sslClusterCertificateSelector, do not use --sslCAFile to specify the root and intermediate CA certificates. Store all CA certificates required to validate the full trust chain of the --sslCertificateSelector and/or --sslClusterCertificateSelector certificates in the secure certificate store.

    For more information about TLS/SSL and MongoDB, see /tutorial/configure-ssl and /tutorial/configure-ssl-clients .

--sslClusterCAFile <filename>
    Deprecated since version 4.2: Use --tlsClusterCAFile instead.

    Specifies the .pem file that contains the root certificate chain from the Certificate Authority used to validate the certificate presented by a client establishing a connection. Specify the file name of the .pem file using relative or absolute paths. --sslClusterCAFile requires that --sslCAFile is set.

    If --sslClusterCAFile does not specify the .pem file for validating the certificate from a client establishing a connection, the cluster uses the .pem file specified in the --sslCAFile option.

    --sslClusterCAFile lets you use separate Certificate Authorities to verify the client to server and server to client portions of the TLS handshake.

Windows/macOS Only
    If using --sslCertificateSelector and/or --sslClusterCertificateSelector, do not use --sslClusterCAFile to specify the root and intermediate CA certificates. Store all CA certificates required to validate the full trust chain of the --sslCertificateSelector and/or --sslClusterCertificateSelector certificates in the secure certificate store.

    For more information about TLS/SSL and MongoDB, see /tutorial/configure-ssl and /tutorial/configure-ssl-clients .

--sslCRLFile <filename>
    Deprecated since version 4.2: Use --tlsCRLFile instead.

    Specifies the .pem file that contains the Certificate Revocation List. Specify the file name of the .pem file using relative or absolute paths.

    NOTE:

•   Starting in MongoDB 4.0, you cannot specify a CRL file on macOS. Instead, you can use the system SSL certificate store, which uses OCSP (Online Certificate Status Protocol) to validate the revocation status of certificates. See --sslCertificateSelector in MongoDB 4.0 and --tlsCertificateSelector in MongoDB 4.2+ to use the system SSL certificate store.

•   Starting in version 4.4, to check for certificate revocation, MongoDB enables the use of OCSP (Online Certificate Status Protocol) by default as an alternative to specifying a CRL file or using the system SSL certificate store.

    For more information about TLS/SSL and MongoDB, see /tutorial/configure-ssl and /tutorial/configure-ssl-clients .

--sslAllowInvalidCertificates
    Deprecated since version 4.2: Use --tlsAllowInvalidCertificates instead.

    Bypasses the validation checks for TLS/SSL certificates on other servers in the cluster and allows the use of invalid certificates to connect.

    NOTE: Starting in MongoDB 4.0, if you specify --sslAllowInvalidCertificates or net.ssl.allowInvalidCertificates: true (or in MongoDB 4.2, the alias --tlsAllowInvalidateCertificates or net.tls.allowInvalidCertificates: true) when using x.509 authentication, an invalid certificate is only sufficient to establish a TLS/SSL connection but is insufficient for authentication.

    When using the --sslAllowInvalidCertificates setting, MongoDB logs a warning regarding the use of the invalid certificate.

    For more information about TLS/SSL and MongoDB, see /tutorial/configure-ssl and /tutorial/configure-ssl-clients .

--sslAllowInvalidHostnames
    Deprecated since version 4.2: Use --tlsAllowInvalidHostnames instead.

    Disables the validation of the hostnames in TLS/SSL certificates, when connecting to other members of the replica set or sharded cluster for inter-process authentication. This allows mongod to connect to other members if the hostnames in their certificates do not match their configured hostname.

    For more information about TLS/SSL and MongoDB, see /tutorial/configure-ssl and /tutorial/configure-ssl-clients .

--sslAllowConnectionsWithoutCertificates
    Deprecated since version 4.2: Use --tlsAllowConnectionsWithoutCertificates instead.

    For clients that do not present certificates, mongod bypasses TLS/SSL certificate validation when establishing the connection.

    For clients that present a certificate, however, mongod performs certificate validation using the root certificate chain specified by --sslCAFile and reject clients with invalid certificates.

    Use the --sslAllowConnectionsWithoutCertificates option if you have a mixed deployment that includes clients that do not or cannot present certificates to the mongod.

    For more information about TLS/SSL and MongoDB, see /tutorial/configure-ssl and /tutorial/configure-ssl-clients .

--sslDisabledProtocols <protocol(s)>
    Deprecated since version 4.2: Use --tlsDisabledProtocols instead.

    Prevents a MongoDB server running with TLS/SSL from accepting incoming connections that use a specific protocol or protocols. To specify multiple protocols, use a comma separated list of protocols.

    --sslDisabledProtocols recognizes the following protocols: TLS1_0, TLS1_1, TLS1_2, and starting in version 4.0.4 (and 3.6.9 and 3.4.24), TLS1_3.

•   On macOS, you cannot disable TLS1_1 and leave both TLS1_0 and TLS1_2 enabled. You must disable at least one of the other two, for example, TLS1_0,TLS1_1.

•   To list multiple protocols, specify as a comma separated list of protocols. For example TLS1_0,TLS1_1.

•   Specifying an unrecognized protocol will prevent the server from starting.

•   The specified disabled protocols overrides any default disabled protocols.

    Starting in version 4.0, MongoDB disables the use of TLS 1.0 if TLS 1.1+ is available on the system. To enable the disabled TLS 1.0, specify none to --sslDisabledProtocols. See 4.0-disable-tls.

    Members of replica sets and sharded clusters must speak at least one protocol in common.

    SEE ALSO: ssl-disallow-protocols

--sslFIPSMode
    Deprecated since version 4.2: Use --tlsFIPSMode instead.

    Directs the mongod to use the FIPS mode of the TLS/SSL library. Your system must have a FIPS compliant library to use the --sslFIPSMode option.

    NOTE: FIPS-compatible TLS/SSL is available only in MongoDB Enterprise. See /tutorial/configure-fips for more information.

  Profiler Options

--profile <level>
    Default: 0

    Configures the database profiler level. The following profiler levels are available:
    Level | Description
    0 | The profiler is off and does not collect any data. This is the default profiler level.
    1 | The profiler collects data for operations that take longer than the value of slowms.
    2 | The profiler collects data for all operations.

    IMPORTANT: Profiling can impact performance and shares settings with the system log. Carefully consider any performance and security implications before configuring and enabling the profiler on a production deployment.

    See database-profiling-overhead for more information on potential performance degradation.

--slowms <integer>
    Default: 100

    The slow operation time threshold, in milliseconds. Operations that run for longer than this threshold are considered slow.

    When logLevel is set to 0, MongoDB records slow operations to the diagnostic log at a rate determined by slowOpSampleRate. Starting in MongoDB 4.2, the secondaries of replica sets log all oplog entry messages that take longer than the slow operation threshold to apply regardless of the sample rate.

    At higher logLevel settings, all operations appear in the diagnostic log regardless of their latency with the following exception: the logging of slow oplog entry messages by the secondaries. The secondaries log only the slow oplog entries; increasing the logLevel does not log all oplog entries.

    For mongod instances, --slowms affects the diagnostic log and, if enabled, the profiler.

    SEE ALSO: /tutorial/manage-the-database-profiler

--slowOpSampleRate <double>
    Default: 1.0

    The fraction of slow operations that should be profiled or logged. --slowOpSampleRate accepts values between 0 and 1, inclusive.

    --slowOpSampleRate does not affect the slow oplog entry logging by the secondary members of a replica set. Secondary members log all oplog entries that take longer than the slow operation threshold regardless of the --slowOpSampleRate.

    For mongod instances, --slowOpSampleRate affects the diagnostic log and, if enabled, the profiler.

  Audit Options

--auditDestination
    Enables auditing and specifies where mongod sends all audit events.

    --auditDestination can have one of the following values:
    Value | Description
    syslog | Output the audit events to syslog in JSON format. Not available on Windows. Audit messages have a syslog severity level of info and a facility level of user. The syslog message limit can result in the truncation of audit messages. The auditing system will neither detect the truncation nor error upon its occurrence.
    console | Output the audit events to stdout in JSON format.
    file | Output the audit events to the file specified in --auditPath in the format specified in --auditFormat.

    NOTE: Available only in MongoDB Enterprise and MongoDB Atlas.

--auditFormat
    Specifies the format of the output file for auditing if --auditDestination is file. The --auditFormat option can have one of the following values:
    Value | Description
    JSON | Output the audit events in JSON format to the file specified in --auditPath.
    BSON | Output the audit events in BSON binary format to the file specified in --auditPath.

    Printing audit events to a file in JSON format degrades server performance more than printing to a file in BSON format.

    NOTE: Available only in MongoDB Enterprise and MongoDB Atlas.

--auditPath
    Specifies the output file for auditing if --auditDestination has value of file. The --auditPath option can take either a full path name or a relative path name.

    NOTE: Available only in MongoDB Enterprise and MongoDB Atlas.

--auditFilter
    Specifies the filter to limit the types of operations the audit system records. The option takes a string representation of a query document of the form:

    { <field1>: <expression1>, ... }

    The <field> can be any field in the audit message, including fields returned in the param document. The <expression> is a query condition expression.

    To specify an audit filter, enclose the filter document in single quotes to pass the document as a string.

    To specify the audit filter in a configuration file, you must use the YAML format of the configuration file.

    NOTE: Available only in MongoDB Enterprise and MongoDB Atlas.

  SNMP Options

NOTE: MongoDB Enterprise on macOS does not include support for SNMP due to SERVER-29352.

--snmp-disabled
    Disables SNMP access to mongod. The option is incompatible with --snmp-subagent and --snmp-master.

    New in version 4.0.6.

--snmp-subagent
    Runs SNMP as a subagent. The option is incompatible with --snmp-disabled.

--snmp-master
    Runs SNMP as a master. The option is incompatible with --snmp-disabled.

    SEE ALSO:

•   /tutorial/monitor-with-snmp

•   /tutorial/monitor-with-snmp-on-windows

•   /tutorial/troubleshoot-snmp

  inMemory Options

--inMemorySizeGB <float>
    Default: 50% of physical RAM less 1 GB

    Changed in version 3.4: Values can range from 256MB to 10TB and can be a float.

    Maximum amount of memory to allocate for in-memory storage engine data, including indexes, oplog if the mongod is part of replica set, replica set or sharded cluster metadata, etc.

    By default, the in-memory storage engine uses 50% of physical RAM minus 1 GB.

Enterprise Feature

    Available in MongoDB Enterprise only.

  Encryption Key Management Options

--enableEncryption <boolean>
    Default: false

    New in version 3.2.

    Enables encryption for the WiredTiger storage engine. You must set to true to pass in encryption keys and configurations.

Enterprise Feature

    Available in MongoDB Enterprise only.

--encryptionCipherMode <string>
    Default: AES256-CBC

    New in version 3.2.

    The cipher mode to use for encryption at rest:
    Mode | Description
    AES256-CBC | 256-bit Advanced Encryption Standard in Cipher Block Chaining Mode
    AES256-GCM | 256-bit Advanced Encryption Standard in Galois/Counter Mode Changed in version 4.0: MongoDB Enterprise on Windows no longer supports AES256-GCM. This cipher is now available only on Linux.

Enterprise Feature

    Available in MongoDB Enterprise only.

--encryptionKeyFile <string>
    New in version 3.2.

    The path to the local keyfile when managing keys via process other than KMIP. Only set when managing keys via process other than KMIP. If data is already encrypted using KMIP, MongoDB will throw an error.

    The keyfile can contain only a single key. The key is either a 16 or 32 character string.

    Requires enableEncryption to be true.

Enterprise Feature

    Available in MongoDB Enterprise only.

--kmipKeyIdentifier <string>
    New in version 3.2.

    Unique KMIP identifier for an existing key within the KMIP server. Include to use the key associated with the identifier as the system key. You can only use the setting the first time you enable encryption for the mongod instance. Requires enableEncryption to be true.

    If unspecified, MongoDB will request that the KMIP server create a new key to utilize as the system key.

    If the KMIP server cannot locate a key with the specified identifier or the data is already encrypted with a key, MongoDB will throw an error

Enterprise Feature

    Available in MongoDB Enterprise only.

--kmipRotateMasterKey <boolean>
    Default: false

    New in version 3.2.

    If true, rotate the master key and re-encrypt the internal keystore.

Enterprise Feature

    Available in MongoDB Enterprise only.

    SEE ALSO: kmip-master-key-rotation

--kmipServerName <string>
    New in version 3.2.

    Hostname or IP address of the KMIP server to connect to. Requires --enableEncryption to be true.

    Starting in MongoDB 4.2.1 (and 4.0.14), you can specify multiple KMIP servers as a comma-separated list, e.g. server1.example.com,server2.example.com. On startup, the mongod will attempt to establish a connection to each server in the order listed, and will select the first server to which it can successfully establish a connection. KMIP server selection occurs only at startup.

    When connecting to a KMIP server, the mongod verifies that the specified --kmipServerName matches the Subject Alternative Name SAN (or, if SAN is not present, the Common Name CN) in the certificate presented by the KMIP server. If SAN is present, mongod does not match against the CN. If the hostname does not match the SAN (or CN), the mongod will fail to connect.

    Starting in MongoDB 4.2, when performing comparison of SAN, MongoDB supports comparison of DNS names or IP addresses. In previous versions, MongoDB only supports comparisons of DNS names.

Enterprise Feature

    Available in MongoDB Enterprise only.

--kmipPort <number>
    Default: 5696

    New in version 3.2.

    Port number to use to communicate with the KMIP server. Requires --kmipServerName. Requires --enableEncryption to be true.

    If specifying multiple KMIP servers with --kmipServerName, the mongod will use the port specified with --kmipPort for all provided KMIP servers.

Enterprise Feature

    Available in MongoDB Enterprise only.

--kmipConnectRetries <number>
    Default: 0

    New in version 4.4.

    How many times to retry the initial connection to the KMIP server. Use together with --kmipConnectTimeoutMS to control how long the mongod waits for a response between each retry.

Enterprise Feature

    Available in MongoDB Enterprise only.

--kmipConnectTimeoutMS <number>
    Default: 5000

    New in version 4.4.

    Timeout in milliseconds to wait for a response from the KMIP server. If the --kmipConnectRetries setting is specified, the mongod will wait up to the value specified with --kmipConnectTimeoutMS for each retry.

    Value must be 1000 or greater.

Enterprise Feature

    Available in MongoDB Enterprise only.

--kmipClientCertificateSelector <string>
    New in version 4.0: Available on Windows and macOS as an alternative to --kmipClientCertificateFile.

    --kmipClientCertificateFile and --kmipClientCertificateSelector options are mutually exclusive. You can only specify one.

    Specifies a certificate property in order to select a matching certificate from the operating system's certificate store to authenticate MongoDB to the KMIP server.

    --kmipClientCertificateSelector accepts an argument of the format <property>=<value> where the property can be one of the following:
    Property | Value type | Description
    subject | ASCII string | Subject name or common name on certificate
    thumbprint | hex string | A sequence of bytes, expressed as hexadecimal, used to identify a public key by its SHA-1 digest. The thumbprint is sometimes referred to as a fingerprint.

Enterprise Feature

    Available in MongoDB Enterprise only.

--kmipClientCertificateFile <string>
    New in version 3.2.

    String containing the path to the client certificate used for authenticating MongoDB to the KMIP server. Requires that a kmipServerName be provided.

    NOTE: Starting in 4.0, on macOS or Windows, you can use a certificate from the operating system's secure store instead of a PEM key file. See --kmipClientCertificateSelector.

Enterprise Feature

    Available in MongoDB Enterprise only.

--kmipClientCertificatePassword <string>
    New in version 3.2.

    The password (if one exists) for the client certificate passed into kmipClientCertificateFile. Is used for authenticating MongoDB to the KMIP server. Requires that a kmipClientCertificateFile be provided.

Enterprise Feature

    Available in MongoDB Enterprise only.

--kmipServerCAFile <string>
    New in version 3.2.

    Path to CA File. Used for validating secure client connection to KMIP server.

    NOTE: Starting in 4.0, on macOS or Windows, you can use a certificate from the operating system's secure store instead of a PEM key file. See --kmipClientCertificateSelector. When using the secure store, you do not need to, but can, also specify the --kmipServerCAFile.

--eseDatabaseKeyRollover
    New in version 4.2.

    Roll over the encrypted storage engine database keys configured with AES256-GCM cipher.

    When mongod instance is started with this option, the instance rotates the keys and exits.

Enterprise Feature

    Available in MongoDB Enterprise only.

AUTHOR
MongoDB Documentation Project

COPYRIGHT
2008-2020